---
{{ template "common.rbac.ServiceAccount" (list .) }}

---
{{ template "common.rbac.ClusterRole" (list . "coredns.rbac.ClusterRole") }}

{{- define "coredns.rbac.ClusterRole" }}
rules:
  - apiGroups:
      - ""
    resources:
      - endpoints
      - namespaces
      - pods
      - services
    verbs:
      - list
      - watch
  - apiGroups:
      - discovery.k8s.io
    resources:
      - endpointslices
    verbs:
      - list
      - watch
{{- end }}

---
{{ template "common.rbac.ClusterRoleBinding" (list . "coredns.rbac.ClusterRoleBinding") }}

{{- define "coredns.rbac.ClusterRoleBinding" }}
roleRef:
  apiGroup: rbac.authorization.k8s.io
  kind: ClusterRole
  name: {{ template "common.fullname" . }}
subjects:
  - kind: ServiceAccount
    name: {{ template "common.fullname" . }}
    namespace: {{ .Release.Namespace }}
{{- end }}
